import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter/widgets.dart';
import 'package:stealth_id/stealth_id.dart';

class AuthExample extends StatefulWidget {
  @override
  _AuthExampleState createState() => _AuthExampleState();
}

class _AuthExampleState extends State<AuthExample> {
  Map _captureMessage = {"message": "response message here"};

  @override
  Widget build(BuildContext context) {
    return Container(
        child: Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        Expanded(
          child: Padding(
              padding: EdgeInsets.only(top: 15),
              child: Text(
                "Face Authentication Example",
                style: TextStyle(fontSize: 25, fontWeight: FontWeight.bold),
              )),
          flex: 1,
        ),
        Expanded(
          flex: 1,
          child: Column(
            mainAxisAlignment: MainAxisAlignment.spaceAround,
            children: [
              RaisedButton.icon(
                icon: Icon(Icons.camera),
                label: Text("Authenticate User Test"),
                onPressed: __onCaptureClickHandler,
              ),
            ],
          ),
        ),
        Expanded(
          flex: 3,
          child: Center(
            child: Text(_captureMessage.toString()),
          ),
        ),
      ],
    ));
  }

  void __onCaptureClickHandler() async {
    try {
      final retornoCapture = await StealthId.authenticateEnrolledUser(
          <String, dynamic>{"userId": "60466b7ca029bb001e31fcb666"});
      setState(() {
        _captureMessage = retornoCapture;
      });
    } on PlatformException catch (error) {
      setState(() {
        _captureMessage['status'] = error.code;
        _captureMessage['message'] = error.message;
      });
    } catch (e) {
      print(e.toString());
    }
  }
}
