//
//  CarespaceDocumentScan.swift
//  risecx_stealthId
//
//  Created by Crístofer Domingues on 15/04/21.
//

import Foundation
import SIPlatformSDK
import SIDocumentSDK
public class CarespaceDocumentScan {
    
    internal var service : CarespaceService
    internal var apiHeader : [String : String]
    internal var viewController : FlutterViewController
    
    init(viewController: FlutterViewController, baseURL:String, apiHeader : [String : String]) {
        self.service = CarespaceService(viewController:viewController, baseURL: baseURL, apiHeader: apiHeader)
        self.apiHeader = apiHeader
        self.viewController = viewController
    }
    
    public func captureOCR(result: @escaping FlutterResult){
        guard let siDocument = SIPlatformSDKManager.shareManager.documentHandler() as? SIDocumentHandler else { return }
        siDocument.captureOCR(sender: self.viewController) { (ocrResult) in
            guard let ocrResultDictionary = ocrResult[0] as? [String:Any] else {
                result(FlutterError.init(code: "CAPTURE_OCR_FAIL", message: "OCR Capture fail", details: ""))
                return
            }
            
            if let description = ocrResultDictionary["description"] as? String {
                result(FlutterError.init(code: "CAPTURE_OCR_FAIL", message: description, details: ""))
                return
            }
            
            print(ocrResult[0])
            result([
                    "Nationality": ocrResultDictionary["Nationality"],
                    "basicInfoLastname": ocrResultDictionary["basicInfoLastname"],
                    "basicInfoDeclaredCitizenship": ocrResultDictionary["basicInfoDeclaredCitizenship"],
                    "Gender": ocrResultDictionary["Gender"],
                    "faceImage": (ocrResultDictionary["faceImage"] as? UIImage)?.toString() ,
                    "Expiry":ocrResultDictionary["Expiry"],
                    "basicInfoDOB": ocrResultDictionary["basicInfoDOB"],
                    "basicInfoDocumentType": ocrResultDictionary["basicInfoDocumentType"],
                    "basicInfoFirstName": ocrResultDictionary["basicInfoFirstName"],
                   // "originalImage":(ocrResultDictionary["originalImage"] as? UIImage)?.toString()
            ])
        }
    }
    
}
